# cs_demo

1. 原理图
+---------------------+                            +-----------------------+
|     client          |                            |       server          |
|                     |    {void** in, void** out} |  +-----------------+  |
|                     +----------------------------+->|                 |  |
|                     |                            |  |     server 0    |  |
|                     |<---------------------------+--+                 |  |
|                     |        {int ack}           |  +-----------------+  |
|                     |                            |                       |
|key data struct:     |                            |                       |
|                     |                            |          .            |
|  1)process_idx      |                            |          .            |
|  2)fetch_idx        |                            |          .            |
|                     |                            |          .            |
|  3)processed_batch  |                            |          .            |
|  4)fetched_batch    |                            |          .            |
|                     |                            |                       |
|  5)mlu_input        |                            |                       |
|  6)mlu_output       |                            |                       |
|                     |                            |                       |
|                     |    {void** in, void** out} |  +------------------+ |
|                     +----------------------------+->|                  | |
|                     |                            |  |     server 3     | |
|                     |<---------------------------+--+                  | |
|                     |         {int ack}          |  +------------------+ |
|                     |                            |                       |
+---------------------+                            +-----------------------+

2. 框架说明
    1) 整体架构采用client/server形式，由client发起请求，server接收请求进行推理，然后将结果返还给client
    2) client、server通过阻塞队列传递消息
    3) 每个server有一组（2个）消息队列，分别用来发和收
       发送的消息包含输入和输出的cpu指针，是个二维数组（因为有多个输入/输出的场景）
       收的消息包括一个int类型的数值即可，表示server处理完了当前的数据
    4) server的数量可以设置，根据模型的属性和实际业务中运行的模型个数来自行决定
    5) client处理的逻辑是，发送不定数量的batch，根据模型的n来决定多少个batch为一组
       比如，模型是4b4c的，那就4个一组发出去
       所谓发4个，实际上是发送输入空间上的一段连续内存，通过地址偏移计算来决定发哪个地址
       同样，输出的地址也要在client侧计算好，然后server直接把输出写在这个起始地址上
    6) client维护了几个关键的数据结构：
        process_idx：代表当前即将要执行推理的server id，就是马上要发数据给它了，如果它是空闲的
        fetch_idx：代表当前即将要取结果的server id
        processed_batch：表示已经发出去的batch数量
        fetched_batch： 表示已经收回来的batch数量
        mlu_input： 本地维护的mlu内存，不用每次malloc，但是需要每次copy
        mlu_output：本地维护mlu内存，用来存放输出
    7) client处理的原则是，只要还有空闲的server，就先赶紧把数据发出去，而不是发完一组，在那等待server返回
       除非server都分配完了，这时再等待server-0的返回结果，一旦收到返回结果，赶紧再发一组数据给server-0
       然后再等待server-1的返回结果，依次循环
       