//
// Created by cambricon on 19-11-28.
//

#include "cnrt.h"  //NOLINT
#include "blockqueue.h"
#include <thread>

using namespace std;

const int worker_out_num = 20;

class InferServer {
public:
    InferServer(int server_id, const char* model_file, BlockQueue<std::pair<void**, void**>>* in, BlockQueue<int>* out);
    ~InferServer();

private:
    void start_work();
    void init_worker();
    bool init_device();
    bool init_ctxt();
    void parse_input_args();
    void parse_output_args();
    bool init_function();
    void parse_args();
    bool start_infer(void** in, void** out);
    void set_input_layout();
    void set_output_layout();

private:
    int server_id_;
    BlockQueue<std::pair<void**, void**>>* queue_in_;
    BlockQueue<int>* queue_out_;
    const char* model_file_;
    bool is_stop_;

    int data_parallel;
    bool is_yuv;
    int device_id_;
    cnrtRuntimeContext_t rt_ctx_;
    cnrtQueue_t queue_;

    cnrtModel_t model;
    cnrtFunction_t function;
    cnrtFunction_t function2;

    int64_t* inputSizeArray_;
    int64_t* outputSizeArray_;

    int* input_dims;
    int input_dims_num;
    int* output_dims[worker_out_num];
    int output_dims_num[worker_out_num];
    cnrtNotifier_t noti_start,noti_end;

    int inputNum, outputNum; //outputnum is output dim
    unsigned int input_n, input_c, input_h, input_w;
    unsigned int output_n[worker_out_num], output_c[worker_out_num], output_h[worker_out_num], output_w[worker_out_num];
    int out_count[worker_out_num]; // equal n*c*h*w
    float inferencer_time;
};
